####################################################################
# (C) Copyright 2013 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard cluster verification script
# @(#) Product Name              :  HP Serviceguard
# @(#) Product Version           :  A.12.10.00
# @(#) Patch Name                :  
#
# *** Note: This file MUST NOT be edited. *****
#
# Any changes made to it will be overwritten when you upgrade to the
# next release of HP Serviceguard.
#
# Changing this file may lead to failures during Cluster verification
#
####################################################################

################################################################
# sg_log_cv logs a message to the specified log file or stdout
#
# Arguments:  $1 : log level
#             $* : message
#
# Globals referenced :
#             SG_LOG_DEBUG :  If initialized by the caller, will log the
#                             message with the log_level set to non-zero.
#
#             SG_LOG_FILE  :  When SG_LOG_DEBUG and SG_LOG_FILE are
#                             initialized by the caller, will log the message
#                             to this file. Else only if SG_LOG_DEBUG is
#                             set message will go to the default log file.
#
#
################################################################

function sg_log_cv
{
    typeset -i log_level=$1 
    shift
    . ${SGCONFFILE:=/etc/cmcluster.conf}
    typeset log_file="${SGROOT}/log/mcs_cv.log"

    if [[ $log_level -eq 0 ]]
    then
        # Log the messages to stdout
        echo "$*"
    else
        # Only when $SG_LOG_DEBUG is set log the messages to the log file else skip it
        if [ -n "$SG_LOG_DEBUG" ]
        then
            if [ -n "$SG_LOG_FILE" ]
            then    
                # Log messages to $SG_LOG_FILE
                log_file=$SG_LOG_FILE
            fi
            echo "$*" >> $log_file
        fi
    fi
}

