####################################################################
# (C) Copyright 2015 Hewlett Packard Enterprise Development LP.
# @(#) Serviceguard UPCC Package Configuration Script.
# @(#) Product Name                :  HP Serviceguard
# @(#) Product Version             :  A.12.10.00
# @(#) Patch Name                  :  
#
# *** Note: This file MUST NOT be edited. *****
#
# Any changes made to it will be overwritten when you upgrade to the
# next release of HP Serviceguard.
#
# Changing this file may lead to unrecoverable package startup
# and/or shutdown problems.
#
###################################################################

###########################
# Source utility functions.
###########################

if [[ -f ${SG_UTILS} ]]; then
    . ${SG_UTILS}
    if (( $? != 0 ))
    then
        echo "ERROR: Unable to source package utility functions file: ${SG_UTILS}"
        exit 1
    fi
else
    echo "ERROR: Unable to find package utility functions file: ${SG_UTILS}"
    exit 1
fi

###################################################################
function check_and_set_pr_module_skip
{
    typeset -i set_pr_module_skip=98
    cleanup_before_exit $set_pr_module_skip
}

################
# main routine
################

case ${1} in
       start)
                # no op
                ;;
        stop)
                check_and_set_pr_module_skip
                ;;
    validate)
                #no op
                ;;
    reconfigure_stop)
                #no op
                ;;
    reconfigure_start)
                #no op
                ;;
           *)
                sg_log 0 "WARNING: Illegal entry point specification $1."
                ;;
esac
