#!/usr/bin/perl -w
##################################################################
# (C) Copyright 2014 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard cluster simulation cluster object 
# @(#) Product Name : HP Serviceguard
# @(#) Product Version : A.12.10.00
# @(#) Patch Name :     
#
# *** Note: This file MUST NOT be edited. *****
#
# Any changes made to it will be overwritten when you upgrade to the
# next release of HP Serviceguard.
#
# Changing this file may lead to issues in Simulator behaviour
#
###################################################################

package CSIMSGCluster;
#require CSIMSGClusterNodes;

sub new {
    my $self = { };
    $self->{name}="";
    $self->{id}=0;
    $self->{status}="down";
    $self->{state}="stable";
    $self->{summary}="critical";
    $self->{coordinator}="none";
    $self->{incarnation}=0;
    $self->{cluster_formation_time}=0;
    $self->{configuration_data_version}=0;
    $self->{member_timeout}=0;
    $self->{io_timeout_extension}=0;
    $self->{configured_io_timeout_extension}=0;
    $self->{auto_start_timeout}=0;
    $self->{network_polling_interval}=0;
    $self->{network_failure_detection}="";
    $self->{network_auto_failback}="";
    $self->{hostname_address_family}="ipv4";
    $self->{max_reformation_duration}=16;
    $self->{max_configured_packages}=300;
    $self->{cfs_online_timeout_changes}=0;
    $self->{max_configured_packages}=0;
    $self->{clusterPRmode}="pr_enabled";
    $self->{nodes}=[];
    $self->{packages}=[];
    $self->{lockLun}=[];
    
    bless $self;
    return $self;
        
}


=pod

=item new <test_case>

This should not be called outside of the SGUtils class,
SGUtils::getCluster() should be used.

=cut
sub getName {
	my $self = shift;
	return $self->{name};
}

=pod

=item new <test_case>

This should not be called outside of the SGUtils class,
SGUtils::getCluster() should be used.

=cut
sub setName {
	my ($self,$val) = @_;
	$self->{name} = $val;
}


=pod

=item getId

=cut
sub getId {
    my ($self) = @_;
    return $self->{id};
}

=pod

=item setId <id>

=cut
sub setId {
    my ($self, $id) = @_;
    $self->{id} = $id;
}

=pod

=item getMaxReformationDuration

=cut
sub getMaxReformationDuration {
    my ($self) = @_;
    return $self->{max_reformation_duration};
}

=pod

=item setMaxReformationDuration <seconds>

=cut
sub setMaxReformationDuration {
    my ($self, $seconds) = @_;
    $self->{max_reformation_duration} = $seconds;
}


=pod

=item getIOTimeoutExtension

=cut
sub getIOTimeoutExtension {
    my ($self) = @_;
    return $self->{io_timeout_extension};
}

=pod

=item setConfiguredIOTimeoutExtension <microseconds>

=cut
sub setIOTimeoutExtension {
    my ($self, $uSeconds) = @_;
    $self->{io_timeout_extension} = $uSeconds;
}

=pod

=item getConfiguredIOTimeoutExtension

=cut
sub getConfiguredIOTimeoutExtension {
    my ($self) = @_;
    return $self->{configured_io_timeout_extension};
}

=pod

=item setConfiguredIOTimeoutExtension <microseconds>

=cut
sub setConfiguredIOTimeoutExtension {
    my ($self, $uSeconds) = @_;
    $self->{configured_io_timeout_extension} = $uSeconds;
}

=pod

=item getStatus

=cut
sub getStatus {
    my ($self) = @_;
    return $self->{status};
}

# internal use only
sub setStatus {
    my ($self, $status) = @_;
    $self->{status} = $status;
}

=pod

=item getState

=cut
sub getState {
    my ($self) = @_;
    return $self->{state};
}

# internal use only
sub setState {
    my ($self, $state) = @_;
    $self->{state} = $state;
}

=pod

=item getSummary

=cut
sub getSummary {
    my ($self) = @_;
    return $self->{summary};
}

# internal use only
sub setSummary {
    my ($self, $summary) = @_;
    $self->{summary} = $summary;
}

=pod

=item getClusterPR

=cut
sub getClusterPR {
    my ($self) = @_;
    return $self->{clusterPRmode};
}

# internal use only
sub setClusterPR {
    my ($self, $clusterPRmode) = @_;
    $self->{clusterPRmode} = $clusterPRmode;
}


=pod

=item getIncarnation

=cut
sub getIncarnation {
    my ($self) = @_;
    return $self->{incarnation};
}

# internal use only
sub setIncarnation {
    my ($self, $incarnation) = @_;
    $self->{incarnation} = $incarnation;
}

=pod

=item getIncarnation

=cut
sub setCfsOnlineTimeoutChanges {
	my ($self, $value) = @_;
    $self->{cfs_online_timeout_changes} = $value;
}

sub getCfsOnlineTimeoutChanges{
	my ($self) = @_;
	return $self->{cfs_online_timeout_changes};
}

=pod

=item getQuiescenceTimeoutExtension

=cut
sub getQuiescenceTimeoutExtension {
    my ($self) = @_;
    return $self->{quiescence_timeout_extension};
}

=pod

=item setQuiescenceTimeoutExtension <seconds>

=cut
sub setQuiescenceTimeoutExtension {
    my ($self, $seconds) = @_;
    $self->{quiescence_timeout_extension} = $seconds;
}


=pod

=item getHostnameResolution

=cut
sub getHostnameResolution {
    my ($self) = @_;
    return uc($self->{hostnameResolution});
}

=pod

=item setHostnameResolution <newHostnameRes>

=cut
sub setHostnameResolution {
    my ($self, $newHostnameRes) = @_;
    $self->{hostnameResolution} = $newHostnameRes;
}

sub getMemberTimeout {
    my ($self) = @_;
    return ($self->getConfigParam("member_timeout"));
}

sub setMemberTimeout{
    my ($self, $newMT) =  @_;
    $self->setConfigParam("member_timeout", $newMT);
}

sub getAutoStartTimeout {
    my ($self) = @_;
    return ($self->getConfigParam("auto_start_timeout"));
}

sub setAutoStartTimeout{
    my ($self, $newAST) =  @_;
    $self->setConfigParam("auto_start_timeout", $newAST);
}


sub setConfigParam {
	my ($self, $name, $value) = @_;
	$self->{$name} = $value;
}

sub getConfigParam {
	my ($self, $name) = @_;
	return $self->{$name};
}

=pod

=item getConfigurationDataVersion

=cut
sub getConfigurationDataVersion {
    my ($self) = @_;
    return $self->{configuration_data_version};
}

# internal use only
sub setConfigurationDataVersion {
    my ($self, $configuration_data_version) = @_;
    $self->{configuration_data_version} = $configuration_data_version;
}

=pod

=item getCmcldModuleVersion <moduleName>

=cut
sub getCmcldModuleVersion {
    my ($self, $moduleName) = @_;
    foreach my $cmcldModule (@{$self->{cmcldModules}}) {
        if ($cmcldModule->getModuleName() eq $moduleName) {
            return $cmcldModule->getModuleVersion();
        }
    }
    return undef;
}

# internal use only
sub addNode {
    my ($self, $node) = @_;
    push(@{$self->{nodes}}, $node);
}
sub getNumOfNodes {
    my ($self) = @_;
    my $numOfNodes = @{$self->{nodes}};
    return $numOfNodes;
}
=pod

=item getNode <name>

Returns an SGNode.

=cut
sub getNode {
    my ($self, $name) = @_;
    foreach my $node (@{$self->{nodes}}) {
        if ($node->getName() eq $name) {
            return $node;
        }
    }
    return undef;
}
# internal use only
sub addPackage {
    my ($self, $pkg) = @_;
    push(@{$self->{packages}}, $pkg);
}

=pod

=item getPackage <name>

Returns an SGPackage.

=cut
sub getPackage {
    my ($self, $name) = @_;
    
    foreach my $pkg (@{$self->{packages}}) {
        if ($pkg->getName() eq $name) {
            return $pkg;
        }
    }

    return undef;
}
sub getFailOverPackageOnNode {
	my ($self,$node_name) = @_;
	my @pkgs = ();
	foreach my $pkg (@{$self->{packages}}) {
	    if ($pkg->getType() eq "failover") {
			if ($pkg->getOwner() eq $node_name) {
				push(@pkgs,$pkg);
			}
		}
    }
	return @pkgs;
}
sub getUnownedPackages {
	my ($self) = @_;
	my @pkgs = ();
	foreach my $pkg (@{$self->{packages}}) {
        if ($pkg->getType() eq "failover" && $pkg->getOwner() eq "unowned" && $pkg->getStatus() ne "running") {
            push(@pkgs,$pkg);
        }
    }
	return @pkgs;
}
sub getMultiNodePackages {
	my ($self) = @_;
	my @pkgs = ();
	foreach my $pkg (@{$self->{packages}}) {
	    
        if ($pkg->getType() eq "multi_node") {
            push(@pkgs,$pkg);
        }
    }
	return @pkgs;

}
# internal use only
sub setQS {
    my ($self, $qsobj) = @_;
    $self->{qs} = $qsobj;
}

=pod

=item getNode <name>

Returns an SGNode.

=cut
sub getQS {
    my ($self) = @_;
    return $self->{qs};
}

# internal use only
sub addLockLun {
    my ($self, $lockLun) = @_;
    push(@{$self->{lockLun}}, $lockLun);
}


sub getLockLun {
    my ($self,$name) = @_;
    foreach my $lunobj (@{$self->{lockLun}}) {
        if ($lunobj->getLockNodeName() eq $name) {
            return $lunobj;
        }
    }
    return undef;
}

1;
