#!/usr/bin/perl -w
##################################################################
# (C) Copyright 2014 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard cluster simulation node object
# @(#) Product Name : HP Serviceguard  
# @(#) Product Version : A.12.10.00 
# @(#) Patch Name :       
#
# *** Note: This file MUST NOT be edited. *****
#
# Any changes made to it will be overwritten when you upgrade to the
# next release of HP Serviceguard.
#
# Changing this file may lead to issues in Simulator behaviour
#
###################################################################

package CSIMSGCluster;
package CSIMSGClusterNodes ;
#require CSIMSGClusterNodeInterface;

sub new {
	my $self = { };
    $self->{name}="";
    $self->{status}="down";
    $self->{state}="unknown";
    $self->{os_status}="up";
    $self->{summary}="critical";
    $self->{id}=1;
    $self->{sgVersion}="A.12.00.20";
    $self->{sgPatch} = undef;
    $self->{localNode} = 0;
    $self->{coordinator} = undef;
    $self->{osRelease}="Not Applicable";
    $self->{os_distribution}="Not Applicable";
    $self->{os_distribution_release}="Not Applicable";
    $self->{os_distribution_description}="This is a simulated environment";
    $self->{cpu_architecture}="Not Applicable";
    $self->{interfaces}=[];
    $self->{subnets}=[];
    $self->{node_pr_key}="";
	$self->{initialIncarnation}=0;
    $self->{bootTime} = undef;
    $self->{siteName} = undef;
    $self->{siteid} = undef;
    $self->{capacities} = [];    
    
    bless $self;
    return $self;
}


# internal use only
# unconvertName() replaces any '|' and '#' name characters with '.' and ':'
# See config/config_line.c convert_name() where we do the opposite.
sub unconvertName {
    my ($self, $name) = @_;
    #confess "missing name" unless $name;
    my $newName = $name;
    $newName =~ s/\|/./g;
    $newName =~ s/#/:/g;
    return $newName;
}
=pod

=item getNode <name>

Returns an SGNode.

=cut
sub getNode {
    my ($self, $name) = @_;
    foreach my $node (@{$self->{nodes}}) {
        if ($node->getName() eq $name) {
            return $node;
        }
    }
    return undef;
}

=pod

=item getName

=cut
sub getName {
    my ($self) = @_;
    return $self->{name};
}

=pod

=item getId

=cut
sub getId {
    my ($self) = @_;
    return $self->{id};
}

=pod

=item setId <id>

=cut
sub setId {
    my ($self, $id) = @_;
    $self->{id} = $id;
}

=pod

=item getPrKey

=cut
sub getPrKey {
    my ($self) = @_;
    return $self->{node_pr_key};
}

=pod

=item setPrKey

=cut
sub constructNodePrKey {
	my ($self, $cid, $nid) = @_;
	my $nprkey = $nid | (($cid & 0x0000ffff) << 16 );
	$self->{node_pr_key} = $nprkey;
	
}
sub setPrKey {
    my ($self, $key) = @_;
    $self->{node_pr_key} = $key;
}


=pod

=item setSiteName <name>

=cut
sub setSiteName {
    my ($self, $name) = @_;
    ##confess "missing name" if !$name;
    $self->{siteName} = $name;
}

=pod

=item getSiteName 

=cut
sub getSiteName {
    my ($self) = @_;
    return $self->{siteName};
}

=pod

=item getSiteId

=cut
sub getSiteId {
    my ($self) = @_;
    return $self->{siteid};
}

=pod

=item setSiteId <id>

=cut
sub setSiteId {
    my ($self, $siteid) = @_;
    #confess "missing siteid" if !$siteid;
    $self->{siteid} = $siteid;
}

=pod

=item isLocalNode

=cut
sub isLocalNode {
    my ($self) = @_;
    return $self->{localNode};
}

=pod

=item isCoordinator

=cut
sub isCoordinator {
    my ($self) = @_;
    return $self->{coordinator};
}

=pod

=item setCoordinator 0|1

=cut
sub setCoordinator {
    my ($self, $value) = @_;
    $self->{coordinator} = $value;
}

=pod

=item getStatus

=cut
sub getStatus {
    my ($self) = @_;
    return $self->{status};
}

# internal
sub setStatus {
    my ($self, $value) = @_;
    $self->{status} = $value;
}

=pod

=item getState

=cut
sub getState {
    my ($self) = @_;
    return $self->{state};
}

# internal
sub setState {
    my ($self, $value) = @_;
    $self->{state} = $value;
}

=pod

=item getSGVersion

=cut
sub getSGVersion {
    my ($self) = @_;
    return $self->{sgVersion};
}

=pod

=item setSGVersion <version>

=cut
sub setSGVersion {
    my ($self, $version) = @_;
    $self->{sgVersion} = $version;
}

=pod

=item getSGPatch

=cut
sub getSGPatch {
    my ($self) = @_;
    return $self->{sgPatch};
}

=pod

=item setSGPatch <version>

=cut
sub setSGPatch {
    my ($self, $version) = @_;
    $self->{sgPatch} = $version;
}

=pod

=item getOSRelease

=cut
sub getOSRelease {
    my ($self) = @_;
    return $self->{osRelease};
}

=pod

=item setOSRelease <release>

=cut
sub setOSRelease {
    my ($self, $release) = @_;
    $self->{osRelease} = $release;
}

=pod

=item getOSDistribution

=cut
sub getOSDistribution {
    my ($self) = @_;
    return $self->{os_distribution};
}

=pod

=item setOSDistribution <distro>

=cut
sub setOSDistribution {
    my ($self, $distro) = @_;
    $self->{os_distribution} = $distro;
}

=pod

=item getOSDistributionRelease

=cut
sub getOSDistributionRelease {
    my ($self) = @_;
    return $self->{os_distribution_release};
}

=pod

=item setOSDistributionRelease <release>

=cut
sub setOSDistributionRelease {
    my ($self, $release) = @_;
    $self->{os_distribution_release} = $release;
}

=pod

=item getOSDistributionDescription

=cut
sub getOSDistributionDescription {
    my ($self) = @_;
    return $self->{os_distribution_description};
}

=pod

=item setOSDistributionDescription <description>

=cut
sub setOSDistributionDescription {
    my ($self, $description) = @_;
    $self->{os_distribution_description} = $description;
}


# internal
sub setOsStatus {
    my ($self, $value) = @_;
    $self->{os_status} = $value;
}

=pod

=item getOsStatus

=cut
sub getOsStatus {
    my ($self) = @_;
    return $self->{os_status};
}

# internal
sub setCpuArch {
    my ($self, $value) = @_;
    $self->{cpu_architecture} = $value;
}

=pod

=item getOsStatus

=cut
sub getCpuArch {
    my ($self) = @_;
    return $self->{cpu_architecture};
}

# internal
sub setInitialIncarnation {
    my ($self, $value) = @_;
    $self->{initialIncarnation} = $value;
}

=pod

=item getInitialIncarnation

=cut
sub getInitialIncarnation {
    my ($self) = @_;
    return $self->{initialIncarnation};
}

# internal
sub setBootTime {
    my ($self, $value) = @_;
    $self->{bootTime} = $value;
}

=pod

=item getBootTime

=cut
sub getBootTime {
    my ($self) = @_;
    #confess "boot time not defined" if !defined($self->{bootTime});
    return ($self->{bootTime});
}

=pod

=item getSummary

=cut
sub getSummary {
    my ($self) = @_;
    return $self->{summary};
}

# internal use only
sub setSummary {
    my ($self, $summary) = @_;
    $self->{summary} = $summary;
}

=pod fillCapacity 

=item fillCapacity

=cut
sub fillCapacity {
    my $self = shift;
    
    my %unfilledCaps = ();
    
    foreach my $weightName (@$SGWeight::AllWeightNames) {
        $unfilledCaps{$weightName} = $weightName;
    }
    foreach my $cap ($self->getCapacities()) {
        delete $unfilledCaps{$cap->getName()};
    }
    
    foreach my $weightName (keys %unfilledCaps) {
        my $newCapacity = SGNodeCapacity->new($weightName);
        $newCapacity->setValue(int(rand(900000) + 100000));
        
        $self->addCapacity($newCapacity);
    }
}

=pod

=item addCapacity <capacityName> <capacityValue>

Add a new capacity name and value to the node

=cut
sub addCapacity {
    my ($self, $capacity) = @_;
    push(@{$self->{capacities}}, $capacity);
}

=pod

=item getCapacity <capacityName>

=cut
sub getCapacity {
    my ($self, $name) = @_;

    foreach my $capacity (@{$self->{capacities}}) {
        if ($capacity->getName() eq $name) {
            return $capacity;
        }
    }
    return undef;
}

=pod

=item deleteCapacity <capacityName>

=cut
sub deleteCapacity {
    my ($self, $name) = @_;
    my @tmp = grep {$_->getName() ne $name} @{$self->{capacities}};
    $self->{capacities} = [@tmp];
}

=pod

=item deleteCapacities

=cut 
sub deleteCapacities {
    my ($self, @capacities) = @_;
    if (@capacities) {
        map { $self->deleteCapacity($_) } @capacities;
    }
    else {
        $self->{capacities} = [];
    }
    
} 

=pod

=item getCapacities

=cut 
sub getCapacities {
    my ($self) = @_;
    return @{$self->{capacities}};
}

=pod

=item getGroupMember <groupName> <memberID>

Return Group member

=cut
sub getGroupMember {
    my ($self,$groupName, $memberID) = @_;
    foreach my $groupMember ($self->getGroupMembers()) {
	if (($groupMember->getGroup->getName eq $groupName) && 
	    ($groupMember->getMemberID eq $memberID)) {
  	    return $groupMember;	
	}
    }
    return ;
}

=pod

=item getGroupMembers

Return Group member list

=cut
sub getGroupMembers {
    my ($self) = @_;
    $self->{cluster}->loadGroups();

    return @{$self->{groupMembers}};
}

=pod

=item setGroupMembers <reference of group member list>

Set Group member

=cut
sub setGroupMembers {
    my ($self,$groupMembers) = @_;
    $self->{groupMembers} = $groupMembers;
}

=pod

=item addGroupMember

=cut
sub addGroupMember {
    my ($self,$groupMember) = @_;
    push(@{$self->{groupMembers}}, $groupMember);
}

=pod

=item getSubnets

Returns a list of SGNodeSubnet

=cut
sub getSubnets {
    my ($self) = @_;
    return @{$self->{subnets}};
}

# internal
=pod

=item addSubnet <SGNodeSubnet object>

=cut

sub addSubnet {
    my ($self, $subnet) = @_;
    foreach my $interface (@{$self->{interfaces}}) {
        foreach my $ipadd (@{$interface->{ipaddress}}) {
            my $sub1 = $ipadd->{subnet};
            my $sub2 = $subnet->getName();
            if ($sub1 && $sub2) {
                if ( $sub1 eq $sub2 ) {
                    push(@{$self->{subnets}}, $subnet);
                }
            }
        }
    }
    
}

=pod

=item deleteSubnet <SGNodeSubnet object>

=cut
sub deleteSubnet {
    my ($self, $name) = @_;
    my @tmp = grep {$_->getName() ne $name} @{$self->{subnets}};
    $self->{subnets} = [@tmp];
}

=pod

=item getSubnet <name>

Returns a SGNodeSubnet
If $needStripIPv6Prefix is set, strip the prefix from the IPv6 addr
For example,
fec0:0:0:a801::/64 will become fec0:0:0:a801::
This needs to be done when dealing with SGIPMonSubnet.

=cut
sub getSubnet {
    my ($self, $name, $needStripIPv6Prefix) = @_;

    foreach my $subnet (@{$self->{subnets}}) {
        my $subnetName = $subnet->getName();
        if ($needStripIPv6Prefix and 
            $self->{sgUtils}->isIPv6Address($subnetName)) {
            $subnetName = $self->{sgUtils}->stripIPv6Prefix($subnetName);
        } 
        if ($subnetName eq $name) {
            return $subnet;
        }
    }
    return undef;
}

=pod

=item getInterfaces

Returns a list of SGInterface

=cut
sub getInterfaces {
    my ($self) = @_;
    return @{$self->{interfaces}};
}

# internal
sub addInterface {
    my ($self, $interface) = @_;
    push(@{$self->{interfaces}}, $interface);
}

=pod

=item deleteInterface <name>

=cut
sub deleteInterface {
    my ($self, $name) = @_;
    my @tmp = grep {$_->getName() ne $name} @{$self->{interfaces}};
    $self->{interfaces} = [@tmp];
}

=pod

=item getInterface <name>

Returns an SGInterface

=cut
sub getInterface {
    my ($self, $name) = @_;
    foreach my $interface (@{$self->{interfaces}}) {
        if ($interface->getName() eq $name) {
            return $interface;
        }
    }
    return undef;
}

sub countAvailableHBs{
    my ($self) = @_;
	my $count = 0;
    foreach my $interface (@{$self->{interfaces}}) {
        foreach my $ipadd (@{$interface->{ipaddress}}) {
            if($ipadd->getHeartbeat() eq "true" && $interface->getStatus() eq "up") {
                $count += 1;
            }
        }
    }
	return $count;
}

=pod

=item getInterfaceByMibIndex <index>

Returns an SGInterface

=cut
sub getInterfaceByMibIndex {
    my ($self, $mibIndex) = @_;
    foreach my $interface (@{$self->{interfaces}}) {
        if ($interface->getMibIndex() and
            $interface->getMibIndex() == $mibIndex) {
            return $interface;
        }
    }
    return undef;
}

package SGInterface;

use Scalar::Util qw(weaken);
use Carp;

# internal
sub new {
    
    my $self = {};
    $self->{name} = "";
    $self->{id} = 1;
    
    $self->{bridgeNet} = 1;
    $self->{status} = "unknown";
    $self->{disabled} = "false";
    $self->{mac_address} = "ff:ff:ff:ae:00:01";
    $self->{mac_type} = "Ethernet";
    $self->{type} = "primary";
    $self->{ppa} = 0;
    $self->{slave} = 0;
    $self->{mibIndex} = undef; 
    $self->{failureType} = '';
    $self->{ipaddress} = [];
    $self->{ipv6Addresses} = [];
    bless $self;
    return $self;
}


=pod

=item getName

=cut
sub getName {
    my ($self) = @_;
    return $self->{name};
}

sub setName {
    my ($self, $value) = @_;
    $self->{name}=$value;
}

=pod

=item getNode

=cut
sub getNode {
    my ($self) = @_;
    return $self->{node};
}


sub setMibIndex {
    my ($self, $value) = @_;
    $self->{mibIndex} = $value;
}

sub getMibIndex {
    my ($self) = @_;
    return $self->{mibIndex};
}
sub setMacAddress {
    my ($self, $value) = @_;
    $self->{mac_address} = $value;
}

sub getMacAddress {
    my ($self) = @_;
    return $self->{mac_address};
}
sub setDisabled {
    my ($self, $value) = @_;
    $self->{disabled} = $value;
}

sub getDisabled {
    my ($self) = @_;
    return $self->{disabled};
}

sub setMacType {
    my ($self, $value) = @_;
    $self->{mac_type} = $value;
}

sub getMacType {
    my ($self) = @_;
    return $self->{mac_type};
}

# internal
sub setType {
    my ($self, $value) = @_;
    $self->{type} = $value;
}

sub getType {
    my ($self) = @_;
    return $self->{type};
}

# internal
sub setStatus {
    my ($self, $value) = @_;
    $self->{status} = $value;
}

=pod

=item getStatus

=cut
sub getStatus {
    my ($self) = @_;
    return $self->{status};
}

sub setFailureType {
    my ($self, $value) = @_;
    $self->{failureType} = $value;
}

sub getFailureType {
    my ($self) = @_;
    return $self->{failureType};
}

# internal
sub setState {
    my ($self, $value) = @_;
    if ($value eq 'true') {
        $self->{state} = "disabled";
    } else {
        $self->{state} = "enabled";
    }
}

=pod

=item getState

=cut
sub getState {
    my ($self) = @_;
    return $self->{state};
}

# internal
sub setSlave {
    my ($self, $value) = @_;
    $self->{slave} = $value;
}

=pod

=item getSlave

=cut
sub getSlave {
    my ($self) = @_;
    return $self->{slave};
}

# internal
sub setPath {
    my ($self, $value) = @_;
    $self->{path} = $value;
}

# internal
sub getPath {
    my ($self) = @_;
    return $self->{path};
}

# internal
sub setNmid {
    my ($self, $value) = @_;
    $self->{nmid} = $value;
}

# internal
sub getNmid {
    my ($self) = @_;
    return $self->{nmid};
}

# internal
sub setPpa {
    my ($self, $value) = @_;
    $self->{ppa}=$value;
}

# internal
sub getPpa {
    my ($self) = @_;
    return $self->{ppa};
}

# internal
sub setId {
    my ($self, $value) = @_;
    $self->{id}=$value;
}

# internal
sub getId {
    my ($self) = @_;
    return $self->{id};
}

# internal
sub setLocalSwitchPeer {
    my ($self, $value) = @_;
    $self->{localSwitchPeer} = $value;
}

# internal
sub getLocalSwitchPeer {
    my ($self) = @_;
    return $self->{localSwitchPeer};
}

=pod

=item isHeartbeat

Returns 1 or 0

=cut
sub isHeartbeat {
    my ($self) = @_;
    if ($self->{heartbeat}) {
        return 1;
    } else {
        return 0;
    }
}

sub isIPv4HBIntf {
    my ($self) = @_;
    if ($self->{heartbeat} eq $SGUtils::IPV4) {
        return 1;
    } else {
        return 0;
    }
}

sub isIPv6HBIntf {
    my ($self) = @_;
    if ($self->{heartbeat} eq $SGUtils::IPV6_SITE_LOCAL ||
        $self->{heartbeat} eq $SGUtils::IPV6_GLOBAL) {
        return 1;
    } else {
        return 0;
    }
}


sub setBridgeNet {
    my ($self, $value) = @_;
    $self->{bridgeNet} = $value;
}

sub getBridgeNet {
    my ($self) = @_;
    return $self->{bridgeNet};
}



sub isIPv6Address {
    my ($self, $ip) = @_;
    # IP will be something like fec0:0:0:1::/64
    if ($ip =~ /\S+\:\S*$/) {
        return 1;
    }
    return 0;
}

=pod

=item isIPv6SiteLocalAddr

Returns 1 if  IPv6 site-local address (Host IP or Subnet) else 0   

=cut
sub isIPv6SiteLocalAddr {
    my ($self, $ip) = @_;
    # IP will be something like fec0:0:0:1::/64
    if ($self->isIPv6Address($ip) && $ip =~ /^fec0/) {
        return 1;
    }
    return 0;
}

=pod

=item isIPv6GlobalAddr

Returns 1 if  IPv6 global address (Host IP or Subnet) else 0   

=cut
sub isIPv6GlobalAddr {
    my ($self, $ip) = @_;
    # IP will be something like 3ffe:1000:0:a803::c0a8:3
    if ($self->isIPv6Address($ip) && 
        ($ip !~ /^fec0/ && $ip !~ /^fe80/)) {
        return 1;
    }
    return 0;
}

=pod

=item isIPv4Address

Returns 1 if  IPv4 address (Host IP or Subnet) else 0   

=cut

sub isIPv4Address {
    my ($self, $ip) = @_;
    # IP will be something line 192.168.1.1
    if ($ip =~ /^\s*[0-9]+\.\S*$/) {
        return 1;
    }
    return 0;
}

=pod

=item isIPv4Only

Returns 1 if no IPv6 subnet is configured

=cut

sub isIPv4Only {
    my ($self) = @_;

    my $sbConf = SBConf->new();
    my $ip_mode = $sbConf->getValue('ip_mode', $SGUtils::UNDEFINED_OK);

    return 1 if $ip_mode and ($ip_mode eq "ipv4_only");

    return 0;
} 

=pod

=item isIPv6Only

Returns 1 if no IPv4 subnet is configured

=cut

sub isIPv6Only {
    my ($self) = @_;

    my $sbConf = SBConf->new();
    my $ip_mode = $sbConf->getValue('ip_mode', $SGUtils::UNDEFINED_OK);
  
    return 1 if $ip_mode and ($ip_mode eq "ipv6_only");

    return 0;
}

sub getIpAddress {
	my ($self, $name) = @_;
	
	foreach my $ipadd (@{$self->{ipaddress}}) {
		if($ipadd->{name} eq $name) {
			return $ipadd;
		}
	}
	return undef;
}

sub addIpAddress {
	my ($self, $ipadd) = @_;
	push(@{$self->{ipaddress}}, $ipadd);
}

package SGInterfaceIPAddress;

sub new {
	my $self = {};
	$self->{name} ="";
	$self->{netmask} = "255.255.255.0";
	$self->{heartbeat} = "false";
	$self->{subnet} = undef;
	$self->{route_id} = undef;
	bless $self;
	return $self;
}
sub getName {
    my ($self) = @_;
    return $self->{name};
}
sub setName {
    my ($self, $value) = @_;
    $self->{name} = $value;
}
sub getNetMask {
    my ($self) = @_;
    return $self->{netmask};
}
sub setNetMask {
    my ($self, $value) = @_;
    $self->{netmask} = $value;
}
sub getSubnet {
    my ($self) = @_;
    return $self->{subnet};
}
sub setSubnet {
    my ($self, $value) = @_;
    $self->{subnet} = $value;
}
sub getRouteId {
    my ($self) = @_;
    return $self->{route_id};
}
sub setRouteId {
    my ($self, $value) = @_;
    $self->{route_id} = $value;
}

sub getHeartbeat {
    my ($self) = @_;
    return $self->{heartbeat};
}
sub setHeartbeat {
    my ($self, $value) = @_;
    $self->{heartbeat} = $value;
}

package SGNodeSubnet;

use Carp;

#internal
sub new {
    my $self = {};
    $self->{name} = "";
    $self->{route_id} = undef;
    $self->{status} = "unknown";
    $self->{ip_monitor} = "off";
    $self->{polling_target} = undef;
    bless $self;
    return $self;
}

sub getName {
    my ($self) = @_;
    return $self->{name};
}
sub setName {
    my ($self, $value) = @_;
    $self->{name} = $value;
}
sub getRouteId {
    my ($self) = @_;
    return $self->{route_id};
}
sub setRouteId {
    my ($self, $value) = @_;
    $self->{route_id} = $value;
}
sub getIpMonitor {
    my ($self) = @_;
    return $self->{ip_monitor};
}
sub setIpMonitor {
    my ($self, $value) = @_;
    $self->{ip_monitor} = $value;
}
sub getStatus {
    my ($self) = @_;
    return $self->{status};
}

sub setStatus {
    my ($self, $value) = @_;
    $self->{status} = $value;
}

sub getPollingTarget {
    my ($self) = @_;
    return $self->{polling_target};
}

sub setPollingTarget {
    my ($self, $value) = @_;
    $self->{polling_target} = $value;
}


=pod

=head1 NAME

SGNodeCapacity - a class for node capacities

=cut
package SGNodeCapacity;


sub new {
    
    my $self = {};
    $self->{capacityName} = "";
    $self->{capacityValue} = 0;
    $self->{capacityUsed} = undef;
    $self->{capacityPercent} = 0;
    bless $self;
    return $self;
}

=pod 

=item setName

=cut
sub setName {
    my ($self, $name) = @_;
    $self->{capacityName} = $name;
}

=pod 

=item getName

=cut
sub getName {
    my $self = shift;
    return $self->{capacityName};
}

=pod 

=item setValue

=cut
sub setValue {
    my ($self, $value) = @_;
    $self->{capacityValue} = $value;
}

=pod 

=item getValue

=cut
sub getValue {
    my $self = shift;
    return $self->{capacityValue};
}

=pod 

=item getUsed

=cut
sub getUsed {
    my $self = shift;
    return $self->{capacityUsed};
}

=pod 

=item setUsed

=cut
sub setUsed {
    my $self = shift;
    $self->{capacityUsed} = shift;
}

=pod

=item setPercent

=cut
sub setPercent {
    my $self = shift;
    $self->{capacityPercent} = shift;
}


=pod

=item getPercent

=cut
sub getPercent {
    my $self = shift;
    return $self->{capacityPercent};
}
=pod

=item getNodes [<status>]

Returns a list of SGNodes.

=cut
sub getNodes {
    my ($self, $status, $siteName) = @_;

    my @nodes = @{$self->{nodes}};
    if ($siteName) {
        my $sgUtils = $self->{sgUtils};
        my @siteNodes = ();
        foreach my $node (@nodes) {
            my $nodeSiteName = $node->getSiteName();
            #confess "Site is not configured for " . $node->getName()
             #   if !$nodeSiteName;
            push(@siteNodes, $node) if ($nodeSiteName eq $siteName);
        }
        @nodes = @siteNodes;
    } 
    if (! defined($status)) {
        return @nodes;
    }
    my @result = ();
    foreach my $node (@nodes) {
        if ($node->getStatus() eq $status) {
            push(@result, $node);
        }
    }
    return @result;
}
package SGLockLun;
sub new {
    my $self = {};
    $self->{node_name} = "";
    $self->{lun} = "";
    $self->{status} = "unknown";
    $self->{interface_type} = "unknown";
    bless $self;
    return $self;
}
sub getLockNodeName {
    my ($self) = @_;
	return $self->{node_name};
}
sub setLockNodeName {
	my ($self,$value) = @_;
	$self->{node_name} = $value;
}
sub getLockLun {
    my ($self) = @_;
	return $self->{lun};
}
sub setLockLun {
	my ($self,$value) = @_;
	$self->{lun} = $value;
}
sub getLockStatus {
    my ($self) = @_;
	return $self->{status};
}
sub setLockStatus {
	my ($self,$value) = @_;
	$self->{status} = $value;
}
sub getLockInterfaceType {
    my ($self) = @_;
	return $self->{interface_type};
}
sub setLockInterfaceType {
	my ($self,$value) = @_;
	$self->{interface_type} = $value;
}



package SGQuorumServer;

sub new {
	my $self = {};
	$self->{name} = "fep3";
	$self->{polling_interval} = 300000000;
	#$self->{nodes} = [];
	$self->{ipaddress} = undef;	
	bless $self;
	return $self; 
}
sub getName {
	my ($self) = @_;
	return $self->{name};
}
sub setName {
	my ($self,$value) = @_;
	$self->{name} = $value;
}
sub getPollingInterval {
	my ($self) = @_;
	return $self->{polling_interval};
}
sub setPollingInterval {
	my ($self,$value) = @_;
	$self->{polling_interval} = $value;
}
sub addNode {
	my($self, $node)= @_;
	push(@{$self->{nodes}},$node);
}

sub setIpAddress {
	my($self, $myipaddress)= @_;
	$self->{ipaddress} = $myipaddress;
}
sub getIpAddress {
	my($self) = @_;
	return $self->{ipaddress};
}


package SGQuorumNode;
sub new {
	my $self = {};
	$self->{name} = "";
	$self->{state} = "unknown";
	$self->{status} = "unknown";
	bless $self;
	return $self; 
}
sub getName {
	my ($self) = @_;
	return $self->{name};
}
sub setName {
	my ($self,$value) = @_;
	$self->{name} = $value;
}
sub getStatus {
	my ($self) = @_;
	return $self->{status};
}
sub setStatus {
	my ($self,$value) = @_;
	$self->{status} = $value;
}

sub getState {
	my ($self) = @_;
	return $self->{state};
}
sub setState {
	my ($self,$value) = @_;
	$self->{state} = $value;
}



package SGQuorumInterface;
sub new {
	my $self = {};
	$self->{ip_address} = "192.168.1.1";
	$self->{nodes} = [];
	bless $self;
	return $self; 
}
sub getIpAddress {
	my ($self) = @_;
	return $self->{ip_address};
}
sub setIpAddress {
	my ($self,$value) = @_;
	$self->{ip_address} = $value;
}
sub addNode {
	my($self, $node)= @_;
	push(@{$self->{nodes}},$node);
}
sub getNode {
	my($self,$nodeName) = @_;
	foreach my $node (@{$self->{nodes}}) {
		if ($node->{name} eq $nodeName) {
			return $node;
		}
	}
	return undef;
}

1; # for perl include

