#!/usr/bin/perl -w
##################################################################
# (C) Copyright 2014 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard cluster simulation package object
# @(#) Product Name : HP Serviceguard
# @(#) Product Version : A.12.10.00
# @(#) Patch Name :     
#
# *** Note: This file MUST NOT be edited. *****
#
# Any changes made to it will be overwritten when you upgrade to the
# next release of HP Serviceguard.
#
# Changing this file may lead to issues in Simulator behaviour
#
###################################################################

package CSIMSGCluster;
package CSIMSGClusterNodes ;
package CSIMSGClusterPackage ;

sub new {
    my $self = { };
    $self->{name} = "";
    $self->{style} = "modular";
    $self->{type} = "failover";
    $self->{status} = "down";
    $self->{state} = "halted";
    $self->{highlyAvailable} = "no";
    $self->{owner} = "unowned";
    $self->{summary} = "degraded";
    $self->{autoRun} = "enabled";
    $self->{package_halted} = "";
    $self->{id} = 0;
    $self->{all_cluster_nodes} = "true";
    $self->{initial_autorun} = "enabled";
    $self->{local_lan_failover_allowed} = "true";
    $self->{failover_policy} = "configured_node";
    $self->{failback_policy} = "manual";
    $self->{failfast} = "disabled";
    $self->{run_script_timeout} = 0;
    $self->{halt_script_timeout} = 0;
    $self->{priority} = "no_priority";
    $self->{successor_halt_timeout} = "no_timeout";
    $self->{script_log_file} = "";
    $self->{dependencies} = [];
    $self->{package_description} = "Serviceguard Package";
    $self->{concurrent_vgchange_operations} = 1;
    $self->{enable_threaded_vgchange} = 0;
    $self->{vgchange_cmd} = "vgchange -a y";
    $self->{vgs} = [];
    $self->{cvm_activation_cmd} = "";
    $self->{vxvol_cmd} ="";
    $self->{vxvm_dg_retry} = "";
    $self->{deactivation_retry_count} = 2;
    $self->{kill_processes_accessing_raw_devices} = "";
    $self->{concurrent_fsck_operations} = 1;
    $self->{concurrent_mount_and_umount_operations} = 1;
    $self->{fs_mount_retry_count} = 0;
    $self->{fs_umount_retry_count} = 1;
    $self->{prMode} = "pr_disabled";
    $self->{node} = [];
    $self->{module} = [];
    $self->{external_script} = [];
    $self->{external_pre_script} = [];
    $self->{file_system} = [];
    $self->{operation_sequence} = [];
    $self->{services} = [];
    $self->{weights} = [];
    $self->{monitored_subnet}=[];
    $self->{ip} = [];
    bless $self;
    return $self; 
}


=pod

=item getName

=cut
sub getName {
    my ($self) = @_;
    return $self->{name};
}

=pod

=item setName <name>

=cut
sub setName {
    my ($self, $name) = @_;
    $self->{name} = $name;
}

=pod

=item getId

=cut
sub getId {
    my ($self) = @_;
    return $self->{id};
}

=pod

=item setId <id>

=cut
sub setId {
    my ($self, $id) = @_;
    $self->{id} = $id;
}
=pod

=item setOwner

Internal use only

=cut
sub setOwner {
    my ($self, $value) = @_;
    $self->{owner} = $value;
}

=pod

=item setPrMode

Set Package PR mode

=cut

sub setPrMode {
    my ($self, $value) = @_;
    $self->{prMode} = $value;
}

=pod

=item getPrMode

Get Package PR mode

=cut

sub getPrMode {
    my ($self) = @_;
    return  $self->{prMode};
}


=pod

=item getOwner

=cut
sub getOwner {
    my ($self) = @_;
    return $self->{owner};
}

=item setHalted

Internal use only

=cut
sub setHalted {
    my ($self, $value) = @_;
    $self->{package_halted} = $value;
}

=pod

=item getHalted

=cut
sub getHalted {
    my ($self) = @_;
    return $self->{package_halted};
}

=pod

=item getFileDirectory

=cut
sub getFileDirectory {
    my ($self) = @_;
    return $self->{fileDir};
}

=pod

=item setStatus

Internal use only

=cut
sub setStatus {
    my ($self, $value) = @_;
    $self->{status} = $value;
}

=pod

=item getStatus

=cut
sub getStatus {
    my ($self) = @_;
    return $self->{status};
}

=pod

=item getSummary

=cut
sub getSummary {
    my ($self) = @_;
    return $self->{summary};
}

# internal use only
sub setSummary {
    my ($self, $summary) = @_;
    $self->{summary} = $summary;
}

sub setLoadedControl {
    my ($self, $value) = @_;
    $self->{loadedControl} = $value;
}

sub setUpdateControl {
    my ($self, $value) = @_;
    $self->{updateControl} = $value;
}

sub setMountPointCreated {
    my ($self, $value) = @_;
    $self->{mountPointCreated} = $value;
}

sub getMountPointCreated {
    my ($self) = @_;
    return $self->{mountPointCreated};
}

sub getPkgDirCreated {
    my ($self) = @_;
    return $self->{pkgDirCreated};
}

sub setPkgDirCreated {
    my ($self, $value) = @_;
    $self->{pkgDirCreated} = $value;
}



sub setExistingPackage {
    my ($self) = @_;
    $self->setPkgDirCreated(1);
    $self->setMountPointCreated(1);
}

sub getHighlyAvailable {
    my ($self) = @_;
    return $self->{highlyAvailable};
}

# internal use only
sub setHighlyAvailable {
    my ($self, $highlyAvailable) = @_;
    $self->{highlyAvailable} = $highlyAvailable;
}

=pod
=item getStyle

returns package style old or upcc

=cut

sub getStyle {
    my ($self) = @_;
    return $self->{style};
}

=pod
=item setStyle

sets the  package style old or upcc
=cut

sub setStyle {
    my ($self, $value) = @_;
    $self->{style} = $value;
}

sub packageIsNonUPCC {
    my ($self) = @_;
    my $style = $self->getStyle();

    return 1 if ($style eq $SGPackage::NONUPCC);
    return 0; 
}

sub packageIsUPCC {
    my ($self) = @_;
    return !$self->packageIsNonUPCC();
}

sub setWeight {
    my ($self, $weight) = @_;
    $self->{value} = $weight;
}


sub getWeight {
    my ($self, $name) = @_;
    foreach my $weight (@{$self->{weights}}) {

        if ($weight->getName() eq $name) {
            return $weight;
        }
    }
    return undef;
}
sub getMonitorSubnet {
    my ($self, $mon_subnet) = @_;
    foreach my $subnet (@{$self->{monitored_subnet}}) {
        if ($subnet->{name} eq $mon_subnet) {
            return $subnet;
        }
    }
    return undef;
}
sub addSubnet {
    my ($self, $subnet) = @_;
	push(@{$self->{monitored_subnet}}, $subnet);
}

sub getIpSubnet {
    my ($self, $ip_subnet) = @_;
    foreach my $ip (@{$self->{ip}}) {
        if ($ip->getIpSubnet() eq $ip_subnet) {
            return $ip;
        }
    }
    return undef;
}
sub addIp {
    my ($self, $ipaddr) = @_;
	push(@{$self->{ip}}, $ipaddr);
}
sub addVg {
    my ($self, $vg) = @_;
    my $found = 0;
    foreach my $vgs (@{$self->{vgs}}) {
        if ($vg eq $vgs) {
            $found = 1; 
        }
    }
    if ($found == 0) {
        push(@{$self->{vgs}}, $vg);
    }
}
sub addWeight {
	my ($self, $weight) = @_;
	push(@{$self->{weights}}, $weight);
}
sub getCluster {
    my ($self) = @_;
    return $self->{cluster};
}

sub addExternalPreScript {
        my ($self, $extpre) = @_;
        push(@{$self->{external_pre_script}}, $extpre);
}

sub addExternalScript {
	my ($self, $ext) = @_;
        # the data structure needs to be updated as we can have
        # only one entry for external_script
        # no need for array
        $self->{external_script}[0] = $ext; 
}
=pod

=item canModifyControlScript

Returns true if the package control script can be changed by Stringbeans.

=cut
sub canModifyControlScript {
    my ($self) = @_;
    return $self->{modifiableControlScript};
}

=pod

=item setModifiableControlScript

Internal use only

=cut
sub setModifiableControlScript {
    my ($self, $value) = @_;
    $self->{modifiableControlScript} = $value;
}

=pod

=item setState

Internal use only

=cut
sub setState {
    my ($self, $value) = @_;
    $self->{state} = $value;
}

=pod

=item getState

=cut
sub getState {
    my ($self) = @_;
    return $self->{state};
}

=pod

=item setAutoRun

Internal use only

=cut
sub setAutoRun {
    my ($self, $value) = @_;
    $self->{autoRun} = $value;
}

=pod

=item getAutoRun

=cut
sub getAutoRun {
    my ($self) = @_;
    return $self->{autoRun};
}

=pod

=item setType

Internal use only

=cut
sub setType {
    my ($self, $value) = @_;
    $self->{type} = lc($value);
}

=pod

=item getType 

=cut
sub getType {
    my ($self) = @_;
    return $self->{type};
}

=pod

=item getDefaultScriptTimeout

=cut
sub getDefaultScriptTimeout {
    my ($self) = @_;
    return $self->{defaultScriptTimeout}; 
}

=pod

=item setDefaultScriptTimeout

=cut
sub setDefaultScriptTimeout {
    my ($self, $value) = @_;
    $self->{defaultScriptTimeout} = $value; 
}

=pod

=item getDefaultServiceTimeout

=cut
sub getDefaultServiceTimeout {
    my ($self) = @_;
    return $self->{defaultServiceTimeout};
}

=pod

=item setConfigParam <name> <value>

=cut
sub setConfigParam {
    my ($self, $name, $value) = @_;
    $self->{$name}=lc($value);
}

=pod

=item unsetConfigParam <name>

=cut
sub unsetConfigParam {
    my ($self, $name) = @_;
    $self->loadConfig();
    # lower case every name
    $name = lc($name);
    
    my $last =  $#{$self->{configParams}};
    for my $i (0 .. $last) { 
        if (exists $self->{configParams}[$i]{$name}) { 
            # remove from array list
            my @deleted = splice(@{$self->{configParams}}, $i, 1);
            last;
        }
    } 
}

=pod

=item getConfigParam <name>

=cut
sub getConfigParam {
        my ($self, $name) = @_;
        return $self->{$name};
}

=pod

=item initialize [<type>]

Internal use only
   Subclasses should extend this

=cut
sub initialize {
    my ($self,$type) = @_;
    my $cmd = "mkdir -p " . $self->{fileDir};

    $self->{testCase}->runAndCheckCommand($cmd,
                                          $SBCase::EXPECT_SUCCESS,
                                          'failed to create directory');
    chmod(0755,$self->{fileDir});
    $self->createAsciiFile($type);

}




sub getTestCase {
    my ($self) = @_;
    return $self->{testCase};
}


sub setPriority {
	my ($self,$value) = @_;
	$self->{priority}=$value;
}

sub getPriority {
	my ($self) = @_;
	return $self->{priority};
}

=pod

=item fillPriority 

Internal use only

=cut

sub fillPriority {
    my ($self) = @_;

    # make 30% packages 'no_priority'
    my $usePri = int(rand(3));
    my $sgUtils = $self->{cluster}->{sgUtils};

    my $pri;
    $pri = $sgUtils->getAvailablePriority($self->{cluster}) if ($usePri);
    $pri = "no_priority" if !$pri; # set to no_priority if no more available
    $self->setPriority($pri);
}

=pod

=item getAddableWeights

Addable weights are all capacities supported by the package's nodes.

=cut
sub getAddableWeights {
    my $self = shift;
    my %unionCapNames = ();
    
    foreach my $pNodeName (map {$_->getName()} $self->getNodes()) {
        my $node = $self->{cluster}->getNode($pNodeName);
        foreach my $capName (map {$_->getName()} $node->getCapacities()) {
            $unionCapNames{$capName} = 1;
        }
    }
    
    return keys %unionCapNames;
}

=pod

=item fillWeight 

adds the weight to package if possible

=cut
sub fillWeight {
    my $self = shift;
    
    my @weightsAddable = $self->getAddableWeights();
    
    foreach my $weightName (@weightsAddable) {
        my $weight = $self->getWeight($weightName);
        next if $weight;
        $weight = SGWeight->new($weightName);
        $weight->setValue(int (rand(100)));
        
        $self->addWeight($weight);
    }

}

=pod

=item getAsciiPath

Internal use only

=cut
sub getAsciiPath {
    my ($self) = @_;
    return $self->{asciiPath};
}

=pod

=item setFailoverPolicy <value>

Internal use only. To change the package failover policy, use
    setConfigParam().

=cut
sub setFailoverPolicy {
    my ($self, $value) = @_;
    $self->setConfigParam('failover_policy', $value);
}

=pod

=item getFailoverPolicy

=cut
sub getFailoverPolicy {
    my ($self) = @_;
    return $self->getConfigParam('failover_policy');
}

=pod

=item setFailbackPolicy <value>

Internal use only. To change the package failback policy, use
    setConfigParam().

=cut
sub setFailbackPolicy {
    my ($self, $value) = @_;
    $self->setConfigParam('failback_policy', $value);
}

=pod

=item getFailbackPolicy

=cut
sub getFailbackPolicy {
    my ($self) = @_;
    return $self->getConfigParam('failback_policy');
}


sub setPackageDescription {
    my ($self, $value) = @_;
    $self->{package_description} = $value;
}

=pod

=item getFailbackPolicy

=cut
sub getPackageDescription {
    my ($self) = @_;
    return $self->{package_description};
}
=pod

=item addNode <SGPackageNode>

Internal use only

=cut
sub addNode {
    my ($self, $packageNode) = @_;
    push(@{$self->{nodes}}, $packageNode);
    # align package contents
    #$self->alignNodeParts();
}

=pod

=item addNewNode <SGPackageNode>

Use this when configuring a package to run on a node it is not already
    configured on.

=cut
sub addNewNode {
    my ($self, $packageNode) = @_;
    # make sure we've loaded the control script since this new node
    # probably doesn't have it yet.
    $self->loadControl();
    $self->addNode($packageNode);
}

=pod

=item getNodes [<status>]

Returns a list of SGPackageNodes.

=cut
sub getNodes {
    my ($self, $status) = @_;

    return @{$self->{nodes}} if (! defined $status);

    my @nodes = grep {$_->getStatus() eq $status} @{$self->{nodes}};
    return @nodes;
}

=pod

=item getNode

=cut
sub getNode {
    my ($self, $name) = @_;
    foreach my $node (@{$self->{nodes}}) {

        if ($node->getName() eq $name) {
            return $node;
        }
    }
    return undef;
}

=pod

=item getMaintenanceNodeName

=cut
sub getMaintenanceNodeName {
    my ($self) = @_;
    foreach my $node (@{$self->{nodes}}) {
        if ($node->getState() eq 'maintenance') {
            return $node->getName();
        }
    }
    return undef; 
}


=pod 

=item groupNodesBySite

group the nodes by site. The first defined node's site
will be first. 

=cut 
sub groupNodesBySite {
    my ($self) = @_;

    # find the site order
    my @siteNameOrder = ();
    foreach my $node ($self->getNodes()) {
        my $clusterNode = $self->{cluster}->getNode($node->getName());
        my $siteName = $clusterNode->getSiteName();
        push(@siteNameOrder, $siteName) unless grep {$_ eq $siteName} @siteNameOrder;
    } 

    my @nodeOrder = ();
    foreach my $siteName (@siteNameOrder) {
        foreach my $node ($self->getNodes()) {
            my $clusterNode = $self->{cluster}->getNode($node->getName());
            if ($clusterNode->getSiteName() eq $siteName) {
                push(@nodeOrder, $node);
            }
        }
    }

    $self->{nodes} = [@nodeOrder];
}

=pod

=item areNodesGroupedBySite

checks if nodes are grouped by site. returns 1 if so, 0 otherwise.

=cut
sub areNodesGroupedBySite {
    my ($self) = @_;
    my %seenSites = ();
    my $lastSite;

    foreach my $pNode ($self->getNodes()) {
        my $clusterNode = $self->{cluster}->getNode($pNode->getName());
        my $siteName = $clusterNode->getSiteName();
        
        if ($seenSites{$siteName} and $lastSite and $lastSite ne $siteName) {
            return 0;
        } 

        $seenSites{$siteName} = 1;
        $lastSite = $siteName;
    }

    return 1;
}

=pod

=item deleteNodes <name> ...

=cut
sub deleteNodes {
    my ($self, @names) = @_;
    die "missing nodes" if ! @names;
    $self->loadConfig();
    my @deletedNodeNames = ();
    foreach my $name (@names) { 
        if (grep {$_->getName() eq $name} @{$self->{nodes}}) {
            push @deletedNodeNames, $name;
            my @tmp = grep {$_->getName() ne $name} @{$self->{nodes}};
            $self->{nodes} = [@tmp];
        }
    }
    # clear the "NODE_NAME *" (if any)
    $self->setConfigParam('NODE_NAME', undef);

    return @deletedNodeNames;
}



=pod

=item getModule

getModule <name>
return module of this <name>
errors out if there is more than 1 by this name

=cut

sub getModule {
    my ($self, $name) = @_;
    # check params
    foreach my $module (@{$self->{module}}) {

        if ($module->getName() eq $name) {
            return $module;
        }
    }
    
    return undef;
}


=pod

=item addModule

addModule <module>

add <module> to this package

=cut

sub addModule {
    my ($self, $mod) = @_;
    push(@{$self->{module}}, $mod);

}


sub addOperationSeq {
	my ($self, $opseq) = @_;
    my $found = 0;
    foreach my $op (@{$self->{operation_sequence}}) {
        if ($op eq $opseq) {
            $found = 1; 
        }
    }
    if ($found == 0) {
        push(@{$self->{operation_sequence}}, $opseq);
    }
}

sub getOperationSeqs {
    return (@{$self->{operation_sequence}});
}

sub addFileSystem {
    my ($self, $mod) = @_;
    push(@{$self->{file_system}}, $mod);
}

sub getFileSystem {
    my ($self, $fs_name) = @_;
    # check params
    foreach my $fileSystem (@{$self->{file_system}}) {
        if ($fileSystem->getName() eq $fs_name) {
            return $fileSystem;
        }
    }
    
    return undef;
}

sub addService {
    my ($self, $mod) = @_;
    push(@{$self->{services}}, $mod);

}
sub getService {
    my ($self, $name) = @_;
    # check params
    foreach my $service (@{$self->{services}}) {

        if ($service->getName() eq $name) {
            return $service;
        }
    }
    
    return undef;
}
sub addDependency {
    my ($self, $dep) = @_;
    push(@{$self->{dependencies}}, $dep);

}
sub getDependency {
    my ($self, $name) = @_;
    foreach my $dependency (@{$self->{dependencies}}) {

        if ($dependency->getName() eq $name) {
            return $dependency;
        }
    }
    return undef;
}

=pod

=head1 NAME

SGPackageNode - class for Serviceguard package node

=cut
package SGPackageNode;

=pod

=item new <name>

=cut
sub new {
    my $self = {};
    $self->{name} = "";
    $self->{last_run_time} = 0; 
    $self->{last_halt_time} = 0;   
    $self->{last_halt_failed} = "no";
    $self->{status} = "down";
    $self->{state} = "unknown";
    $self->{order} = 1;
    $self->{type} =  "Alternate";
    $self->{switching} = "enabled";
    $self->{available} = "yes";
    $self->{subnets} = []; 
    $self->{resources} = [];
    $self->{dependencies} = []; 
    $self->{services} = []; 
    bless $self;
    return $self;
}

=pod

=item getName

=cut
sub getName {
    my ($self) = @_;
    return $self->{name};
}

=pod

=item setName

=cut
sub setName {
    my ($self, $value) = @_;
    $self->{name} = $value;    
}

=pod

=item setStatus

Internal use only

=cut
sub setStatus {
    my ($self, $value) = @_;
    $self->{status} = $value;
}

=pod

=item getStatus

=cut
sub getStatus {
    my ($self) = @_;
    return $self->{status};
}

=pod

=item setState

Internal use only

=cut
sub setState {
    my ($self, $value) = @_;
    $self->{state} = $value;
}

=pod

=item getState

=cut
sub getState {
    my ($self) = @_;
    return defined($self->{state}) ? $self->{state} : "";
}

=pod

=item setLastHaltFailed

Internal use only

=cut
sub setLastHaltFailed {
    my ($self, $value) = @_;
    $self->{last_halt_failed} = $value;
}

=pod

=item getLastHaltFailed

=cut
sub getLastHaltFailed {
    my ($self) = @_;
    return defined($self->{last_halt_failed}) ? $self->{last_halt_failed} : "no";
}

=pod

=item getAvailable

=cut
sub getAvailable {
    my ($self) = @_;
    return $self->{available};
}

# internal use only
sub setAvailable {
    my ($self, $available) = @_;
    $self->{available} = $available;
}

=pod

=item setSwitching

Internal use only

=cut
sub setSwitching {
    my ($self, $value) = @_;
    $self->{switching} = $value;
}

=pod

=item getSwitching

=cut
sub getSwitching {
    my ($self) = @_;
    return defined($self->{switching}) ? $self->{switching} : "";
}

=pod

=item setType

Internal use only

=cut
sub setType {
    my ($self, $value) = @_;
    $self->{type} = $value;
}

=pod

=item getType

=cut
sub getType {
    my ($self) = @_;
    return $self->{type};
}

=pod

=item setOrder

Internal use only

=cut
sub setOrder {
    my ($self, $value) = @_;
    $self->{order} = $value;
}

=pod

=item getOrder

=cut
sub getOrder {
    my ($self) = @_;
    return $self->{order};
}

=pod

=item setLastRunTime

Internal use only

=cut
sub setLastRunTime {
    my ($self, $value) = @_;
    $self->{last_run_time} = $value;
}

=pod

=item getLastRunTime

=cut
sub getLastRunTime {
    my ($self) = @_;
    return $self->{last_run_time};
}

=pod

=item setLastHaltTime

Internal use only

=cut
sub setLastHaltTime {
    my ($self, $value) = @_;
    $self->{last_halt_time} = $value;
}

=pod

=item getLastHaltTime

=cut
sub getLastHaltTime {
    my ($self) = @_;
    return $self->{last_halt_time};
}

=pod

=item addSubnetNode <SGPackagePartNode>

Internal use only

=cut
sub addSubnetNode {
    my ($self, $subnet) = @_;
    push(@{$self->{subnets}}, $subnet);
}

=pod

=item getSubnetNodes

Returns a list of SGPackagePartNodes.

=cut
sub getSubnetNodes {
    my ($self) = @_;
    return @{$self->{subnets}};
}

=pod

=item getSubnetNode

Returns an SGPackagePartNode.

=cut
sub getSubnetNode {
    my ($self, $name) = @_;
    my ($result) = grep {$_->getPartName() eq $name} @{$self->{subnets}};
    return $result;
}


=pod

=item getResourceNodes

Returns a list of SGPackagePartNodes

=cut
sub getResourceNodes {
    my ($self) = @_;
    return @{$self->{resources}};
}

# internal
sub addResourceNode {
    my ($self, $resource) = @_;
    push(@{$self->{resources}}, $resource);
}

=pod

=item getResourceNode <name>

Returns an SGPackagePartNode

=cut
sub getResourceNode {
    my ($self, $name) = @_;
    foreach my $resource (@{$self->{resources}}) {
        if ($resource->getPartName() eq $name) {
            return $resource;
        }
    }
    return undef;
}

=pod

=item addDependencyNode

Internal use only

=cut
sub addDependencyNode {
    my ($self, $dependency) = @_;
    push(@{$self->{dependencies}}, $dependency);
}

=pod

=item getDependencyNodes

Returns a list of SGPackagePartNode

=cut
sub getDependencyNodes {
    my ($self) = @_;
    return @{$self->{dependencies}};
}

=pod

=item getDependencyNode <name>

Returns an SGPackagePartNode

=cut
sub getDependencyNode {
    my ($self, $name) = @_;
    foreach my $dependency (@{$self->{dependencies}}) {
        if ($dependency->getPartName() eq $name) {
            return $dependency;
        }
    }
    return undef;
}


=pod

=item deleteDependencyNodes

Removes dependency nodes from package node.

=cut
sub deleteDependencyNodes {
    my ($self, @names) = @_;
    if ( ! @names) {
        $self->{dependencies} = [];
    }
    else {
        my @tmp;
        foreach my $name (@names) {
            @tmp = grep { $_->getPartName() ne $name } 
                    @{$self->{dependencies}};
            $self->{dependencies} = [@tmp]; 
        }
    }
}

=pod

=item addServiceNode <SGPackageServiceNode>

Internal use only

=cut
sub addServiceNode {
    my ($self, $serviceNode) = @_;
    push(@{$self->{services}}, $serviceNode);
}

=pod

=item getServiceNodes

Returns a list of SGPackageServiceNodes.

=cut
sub getServiceNodes {
    my ($self) = @_;
    return @{$self->{services}};
}

=pod

=item getServiceNode

Returns an SGPackageServiceNode.

=cut
sub getServiceNode {
    my ($self, $name) = @_;
    foreach my $sNode (@{$self->{services}}) {
        if ($sNode->{name} eq $name) {
            return $sNode;
        }
    }
    return undef;
    
}

=pod

=item toString

=cut
sub toString {
    my ($self) = @_;
    my $name = $self->getName();
    my $status = $self->getStatus();
    my $state = $self->getState();
    my $switch = $self->getSwitching();
    my $type = $self->getType();
    
    my  $result = "  pNode $name";
    $result .= " $status" if $status;
    $result .= " $state" if $state;
    $result .= " $switch" if $switch;
    $result .= " $type" if $type;
    $result .= "\n";
    
    foreach my $subnetNode ($self->getSubnetNodes()) {
        $result .= $subnetNode->toString();
    }
    foreach my $resourceNode ($self->getResourceNodes()) {
        $result .= $resourceNode->toString();
    }
    foreach my $dependencyNode ($self->getDependencyNodes()) {
        $result .= $dependencyNode->toString();
    }
    foreach my $serviceNode ($self->getServiceNodes()) {
        $result .= $serviceNode->toString();
    }
    return $result;
}

package SGPackageModule;

sub new {
    
    my $self = {};
    $self->{name} = undef;
    $self->{module_version} = "";
    $self->{module_script} = "";
    bless $self;
    return $self;

}
sub getName {
    my ($self) = @_;
    return $self->{name};
}

sub setName {
    my ($self, $value) = @_;
    $self->{name} = $value;
}
sub getVersion {
    my ($self) = @_;
    return $self->{module_version};
}

sub setVersion {
    my ($self, $value) = @_;
    $self->{module_version} = $value;
}
sub getScript {
    my ($self) = @_;
    return $self->{module_script};
}

sub setScript {
    my ($self, $value) = @_;
    $self->{module_script} = $value;
}


package SGPackageFileSystem;

sub new {
    
    my $self = {};
    $self->{fs_name} = undef;
    $self->{fs_server} = "";
    $self->{fs_directory} = "";
    $self->{fs_type} = "";
    $self->{fs_mount_opt} = "";
    $self->{fs_umount_opt} = "";
    $self->{fs_fsck_opt} = "";
    
    bless $self;
    return $self;

}
sub getName {
    my ($self) = @_;
    return $self->{fs_name};
}

sub setName {
    my ($self, $value) = @_;
    $self->{fs_name} = $value;
}

sub getFsServer {
    my ($self) = @_;
    return $self->{fs_server};
}

sub setFsServer {
    my ($self, $value) = @_;
    $self->{fs_server} = $value;
}

sub getFsType {
    my ($self) = @_;
    return $self->{fs_type};
}

sub setFsType {
    my ($self, $value) = @_;
    $self->{fs_type} = $value;
}

sub getFsDirectory {
    my ($self) = @_;
    return $self->{fs_directory};
}

sub setFsDirectory {
    my ($self, $value) = @_;
    $self->{fs_directory} = $value;
}

sub getFsMountOpt {
    my ($self) = @_;
    return $self->{fs_mount_opt};
}

sub setFsMountOpt {
    my ($self, $value) = @_;
    $self->{fs_mount_opt} = $value;
}

sub getFsUMountOpt {
    my ($self) = @_;
    return $self->{fs_umount_opt};
}

sub setFsUMountOpt {
    my ($self, $value) = @_;
    $self->{fs_umount_opt} = $value;
}

sub getFsFsckOpt {
    my ($self) = @_;
    return $self->{fs_fsck_opt};
}

sub setFsFsckOpt {
    my ($self, $value) = @_;
    $self->{fs_fsck_opt} = $value;
}

package SGPackageService;

sub new {
    my $self = {};
    $self->{name} = "";
    $self->{id} = undef;
    $self->{failfast} = "no";
    $self->{halt_timeout} = undef;
    $self->{command} = undef;
    $self->{restart} = "none";
    bless $self;
    return $self;
}

sub getName {
    my ($self) = @_;
    return $self->{name};
}

sub setName {
    my ($self, $value) = @_;
    $self->{name} = $value;
}
sub getServiceConfigParam {
	my ($self, $param) = @_;
	return $self->{$param};
}
sub setServiceConfigParam {
	my ($self, $param, $value) = @_;
	$self->{$param} = $value;
}

package SGPackageServiceNode;
sub new {
	my $self = {};
	$self->{service_name} = "";
	$self->{name} = "";
    $self->{status} = undef;
    $self->{pid} = undef;
    $self->{restart_limit} = undef;
    $self->{restart_count} = undef;
   
	bless $self;
    return $self;
}


sub setMaxRestarts {
    my ($self, $value) = @_;
    $self->{restart_limit} = $value;
}

sub getMaxRestarts {
    my ($self) = @_;
    return $self->{restart_limit};
}

sub setRestarts {
    my ($self, $value) = @_;
    $self->{restart_count} = $value;
}

sub getRestarts {
    my ($self) = @_;
    return $self->{restart_count};
}

sub setPid {
    my ($self, $value) = @_;
    $self->{pid} = $value;
}

sub getPid {
    my ($self) = @_;
    return $self->{pid};
}
sub setStatus {
    my ($self, $value) = @_;
    $self->{status} = $value;
}

sub getStatus {
    my ($self) = @_;
    return $self->{status};
}

sub setName {
    my ($self, $value) = @_;
    $self->{name} = $value;
}

sub getName {
    my ($self) = @_;
    return $self->{name};
}
sub setServiceName {
    my ($self, $value) = @_;
    $self->{service_name} = $value;
}
sub getServiceName {
    my ($self) = @_;
    return $self->{name};
}

package SGWeight;
sub new {
    my $self =  {};
    $self->{name} = "";
    $self->{value} = undef;
    bless $self;
    return $self;
}
sub setName {
    my ($self, $name) = @_;
    $self->{name} = $name;
}
sub getName {
    my $self = shift;
    return $self->{name};
}
sub setValue {
    my ($self, $value) = @_;
    $self->{value} = $value;
}
sub getValue {
    my $self = shift;
    return $self->{value};
}

package SGDependency;
sub new {
	my $self = {};
	$self->{name} = "";
    $self->{package_id} = undef;
    $self->{location} = "same_node";
    $self->{condition} = undef;
    #$self->{node} = [{
    #		'name' => "",
    #		'satisfied' => ""
    #}];
    $self->{node} = [];
	bless $self;
    return $self;
}
sub getName {
	my $self = shift;
	return $self->{name};
}
sub setName {
	my ($self, $value) = @_;
	$self->{name} = $value;
}
sub getPackageId {
	my $self = shift;
	return $self->{package_id};
}
sub setPackageId {
	my ($self, $package_id) = @_;
	$self->{package_id} = $package_id;
}
sub getLocation {
	my $self = shift;
	return $self->{location};
}
sub setLocation {
	my ($self, $location) = @_;
	$self->{location} = $location;
}
sub getCondition {
	my $self = shift;
	return $self->{condition};
}
sub setCondition {
	my ($self, $name) = @_;
	$self->{condition} = $name;
}
sub addNode {
	my ($self, $nodeName, $satisfied) = @_;
    my $node = {};
	$node->{name} = $nodeName;
  	$node->{satisfied} = $satisfied;
	push(@{$self->{node}}, $node);
	
}
sub getNode {
	my $self = shift;
	return $self->{node};
}	

package SGPackageMonitorSubnet;

sub new {
    my $self = {};
    $self->{name} = "";
    $self->{monitored_subnet_access} = "full";
    $self->{node} = [];
    bless $self;
    return $self;
}
sub setMonitorSubnet {
	my ($self, $value) = @_;
	$self->{name} = $value;
}
sub getMonitorSubnet {
	my $self = shift;
	return $self->{subnet};
}

sub setMonitorSubnetAccess {
	my ($self, $value) = @_;
	$self->{monitored_subnet_access} = $value;
}
sub getMonitorSubnetAccess {
	my $self = shift;
	return $self->{monitored_subnet_access};
}

sub getMonitorSubnetNode {
   my ($self, $monitored_subnet_node) = @_;
    foreach my $node (@{$self->{node}}) {
        if ($node->{name} eq $monitored_subnet_node) {
            return $node;
        }
    }
    return undef;
}

sub addMonitorSubnetNode {
    my ($self, $subnetNode) = @_;
    push(@{$self->{node}}, $subnetNode);
       
}

package SGPackageMonitorSubnetNode;

sub new {
    my $self = {};
    $self->{name} = "";
    $self->{status} = "unknown";
    bless $self;
    return $self;
}

sub setMonitorSubnetNode {
        my ($self, $value) = @_;
        $self->{name} = $value;
}

sub getMonitorSubnetNode {
        my $self = shift;
        return $self->{name};
}

sub setMonitorSubnetNodeStatus {
        my ($self, $value) = @_;
        $self->{status} = $value;
}

sub getMonitorSubnetStatus {
        my $self = shift;
        return $self->{status};
}

package SGPackageIP;

sub new {
    my $self = {};
    $self->{ip_address} = [];
    $self->{ip_subnet} = "";
    $self->{ip_subnet_node} = "";
    bless $self;
    return $self;
}

sub getIpAddress {
       my ($self, $ip) = @_;
       foreach my $package_ip (@{$self->{ip_address}}) {
           if ($package_ip->{name} eq $ip) {
               return $package_ip;
           }
       }
}

sub addIpAddress {
        my ($self, $value) = @_;
        push(@{$self->{ip_address}}, $value);
}

sub getIpSubnet {
	my $self = shift;
	return $self->{ip_subnet};
}

sub setIpSubnet {
	my ($self, $value) = @_;
	$self->{ip_subnet} = $value;
}

sub getIpSubnetNode {
	my $self = shift;
	return $self->{ip_subnet_node};
}

sub setIpSubnetNode {
	my ($self, $value) = @_;
	$self->{ip_subnet_node} = $value;
}

package SGPackageIPName;

sub new {
    my $self = {};
    $self->{name} = "";
    bless $self;
    return $self;
}

sub setPackageIPName {
        my ($self, $value) = @_;
        $self->{name} = $value;

}

sub getPackageIPName {
        my $self = shift;
        return $self->{name};

}

package SGPackageExternalPreScript;

sub new {
    my $self = {};
    $self->{name} = "";
    bless $self;
    return $self;
}

sub setExternalPreScript {
    my ($self, $value) = @_;
    $self->{name} = $value;
}

sub getExternalPreScript {
    my $self = shift;
    return $self->{name};
}

1;


