####################################################################
# (C) Copyright 2007 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard MGFileSystem.pm
# @(#) Product Name                : HP Serviceguard
# @(#) Product Version             : A.12.10.00
# @(#) Patch Name                  : 
####################################################################

package MGPackage;

sub getFileSystems 
{
    my ($self) = @_;
    return @{$self->{fileSystems}};
}

=pod

=item getFileSystem <name>

Returns a list of SGFileSystem

=cut
sub getFileSystem 
{
    my ($self,$name) = @_;
    foreach my $filesystem (@{$self->{fileSystems}}) {
        if ($filesystem->getName() eq $name) {
            return $filesystem;
        }
    }
    return undef;
}

package MGFileSystem;

=pod

=item new

Internal use only

=cut
sub new {
    my ($pkg, $name) = @_;
    my $self = {};
    $self->{name} = $name;
    die "missing name" if ! $self->{name};
    bless $self, $pkg;
    return $self;
}

=pod

=item getName

=cut
sub getName {
    my ($self) = @_;
    return $self->{name};
}

=pod

=item setDevice <value>

=cut
sub setDevice {
    my ($self, $value) = @_;
    $self->{device} = $value;
}

=pod

=item getDevice

=cut
sub getDevice {
    my ($self) = @_;
    return $self->{device};
}

=pod

=item setType <value>

=cut
sub setType {
    my ($self, $value) = @_;
    $self->{type} = $value;
}

=pod

=item getType

=cut
sub getType {
    my ($self) = @_;
    return $self->{type};
}


=pod

=item setMountPoint <value>

=cut
sub setMountPoint {
    my ($self, $value) = @_;
    $self->{mountPoint} = $value;
}

=pod

=item getMountPoint

=cut
sub getMountPoint{
    my ($self) = @_;
    return $self->{mountPoint};
}

=pod

=item setMountOptions <value>

=cut
sub setMountOptions {
    my ($self, $value) = @_;
    $self->{mountOptions} = $value; 
}

=pod

=item getMountOptions

=cut
sub getMountOptions {
    my ($self) = @_;
    return $self->{mountOptions}; 
}

=pod

=item setUmountOptions <value>

=cut
sub setUmountOptions {
    my ($self, $value) = @_;
    $self->{umountOptions} = $value; 
}

=pod

=item getUmountOptions

=cut
sub getUmountOptions {
    my ($self) = @_;
    return $self->{umountOptions}; 
}

=pod

=item setFsckOptions <value>

=cut
sub setFsckOptions {
    my ($self, $value) = @_;
    $self->{fsckOptions} = $value; 
}

=pod

=item getFsckOptions

=cut
sub getFsckOptions {
    my ($self) = @_;
    return $self->{fsckOptions}; 
}

=pod

=item setRawVolume 

=cut
sub setRawVolume {
    my ($self) = @_;

    # set mount, umount and fsck options to '-V'
    # so no action performed when mount, umount and fsck 
    $self->setType('unknown');
    $self->setMountOptions('-V -F hfs');
    $self->setUmountOptions('-V -F hfs');
    $self->setFsckOptions('-V');

}

1; # for perl include
