####################################################################
# (C) Copyright 2007 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard cmmigratepkg
# @(#) Product Name                : HP Serviceguard
# @(#) Product Version             : A.12.10.00
# @(#) Patch Name                  : 
####################################################################

package MGPackage;

=pod

=item addDependency

=cut
sub addDependency {
    my ($self, $dependency, $trace) = @_;
    die "missing dependency" if !$dependency;
    push(@{$self->{dependencies}}, $dependency);
}

=pod

=item getDependencies

Returns a list of SGPackageDependency.

=cut
sub getDependencies {
    my ($self) = @_;
    return @{$self->{dependencies}};
}

=pod

=item getDependency <name>

Returns an SGPackageDependency.

=cut
sub getDependency {
    my ($self, $name) = @_;
    foreach my $dependency (@{$self->{dependencies}}) {
        if ($dependency->getName() eq $name) {
            return $dependency;
        }
    }
    return undef;
}

# end of dependency related subroutines for packages

=pod

=head1 NAME

MGPackageDependency - class for Serviceguard package dependencies

=cut
package MGPackageDependency;
use strict;
use Carp;
use Scalar::Util qw(weaken);

=pod

=item new <name>

=cut
sub new {
    my $pkg = shift;
    my $self = {};
    weaken($self->{pkg} = shift);
    die "missing pkg" unless $self->{pkg};
    $self->{name} = shift;
    die "missing name" unless $self->{name};

    $self->{dependee} = undef;
    $self->{status} = "UP";
    $self->{location} = "SAME_NODE";
    bless $self, $pkg;
    return $self;
}

=pod

=item getName

=cut
sub getName {
    my ($self) = @_;
    return $self->{name};
}

=pod

=item setName <value>

=cut
sub setName {
    my ($self, $value) = @_;
    $self->{name} = $value;
}

=pod

=item getDependee

=cut
sub getDependee {
    my ($self) = @_;
    return $self->{dependee};
}

=pod

=item setDependee <value>

=cut
sub setDependee {
    my ($self, $value) = @_;
    $self->{dependee} = $value;
}

=pod

=item getStatus

=cut
sub getStatus {
    my ($self) = @_;
    return $self->{status};
}

=pod

=item setStatus <value>

=cut
sub setStatus {
    my ($self, $value) = @_;
    $self->{status} = $value;
}

=pod

=item getCondition

=cut
sub getCondition {
    my ($self) = @_;
    return $self->getDependee() . " = " . $self->getStatus();
}

=pod

=item getLocation

=cut
sub getLocation {
    my ($self) = @_;
    return $self->{location};
}

=pod

=item setLocation <value>

=cut
sub setLocation {
    my ($self, $value) = @_;
    $self->{location} = $value;
}


1; # for perl include
