####################################################################
# (C) Copyright 2007 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard MGPackageWeight.pm
# @(#) Product Name                : HP Serviceguard
# @(#) Product Version             : A.12.10.00
# @(#) Patch Name                  : 
####################################################################

package MGPackage;

=pod

=item addWeight

=cut
sub addWeight {
    my ($self, $weight, $trace) = @_;
    die "missing weight" if !$weight;
    push(@{$self->{weights}}, $weight);
}

=pod

=item getWeights

Returns a list of SGPackageWeight.

=cut
sub getWeights {
    my ($self) = @_;
    return @{$self->{weights}};
}

=pod

=item getWeight <name>

Returns an SGPackageWeight.

=cut
sub getWeight {
    my ($self, $name) = @_;
    foreach my $weight (@{$self->{weights}}) {
        if ($weight->getName() eq $name) {
            return $weight;
        }
    }
    return undef;
}

# end of weight related subroutines for packages

=pod

=head1 NAME

MGPackageWeight - class for Serviceguard package weights

=cut
package MGPackageWeight;
use strict;
use Carp;
use Scalar::Util qw(weaken);

=pod

=item new <name>

=cut
sub new {
    my $pkg = shift;
    my $self = {};
    weaken($self->{pkg} = shift);
    die "missing pkg" unless $self->{pkg};
    $self->{name} = shift;
    die "missing name" unless $self->{name};

    $self->{value} = undef;
    bless $self, $pkg;
    return $self;
}

=pod

=item getName

=cut
sub getName {
    my ($self) = @_;
    return $self->{name};
}

=pod

=item setName <value>

=cut
sub setName {
    my ($self, $value) = @_;
    $self->{name} = $value;
}

=pod

=item getValue

=cut
sub getValue {
    my ($self) = @_;
    return $self->{value};
}

=pod

=item setValue <value>

=cut
sub setValue {
    my ($self, $value) = @_;
    $self->{value} = $value;
}

1; # for perl include
