####################################################################
# (C) Copyright 2007 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard MGUser.pm
# @(#) Product Name                : HP Serviceguard
# @(#) Product Version             : A.12.10.00
# @(#) Patch Name                  : 
####################################################################

=pod

=head1 NAME

MGUser - a class for Serviceguard Access Control Policies,
which contain the fields USER_NAME, USER_ROLE and USER_HOST

=cut

package MGUser;

use strict;
use Carp;

=pod

=item new

One of two constructors. 
This one expects its user to follow similar procedures to that in create.
getDefaultHosts, determineHost, and translateRole should all help.

=cut

sub new {
    my ($pkg,$value) = @_;
    my $self = {};
    bless $self, $pkg;

    $self->{names} = $value;
    return $self;
}

=pod

=item getNames

=cut

sub getNames {
    my ($self) = @_;
    return @{$self->{names}};
}

=pod

=item getHost

=cut

sub getHost {
    my ($self) = @_;
    return $self->{host};
}

=pod

=item setHost <userHostValue>

<userHostValue> is expected to be understood as an value of USER_HOST
	in the ascii file
(ie "ANY_SERVICEGUARD_NODE", "CLUSTER_MEMBER_NODE", or a specific node)

=cut

sub setHost {
    my ($self, $host) = @_;
    $self->{host} = $host;
    return;
}

=pod

=item getRole

=cut

sub getRole {
    my ($self) = @_;
    return $self->{role};
}

=pod

=item setRole <userRole>

<userRole> is expected to be understood as an value of USER_ROLE
	in the ascii file
(ie full_admin package_admin monitor)

=cut


sub setRole {
    my ($self, $role) = @_;
    $self->{role} = $role;
    return;
}

=pod

=item getAscii

generate correct formated information for ascii file

=cut

sub getAscii {
    my ($self, $level) = @_;

    my $name = join(" ", $self->getNames());
    my $role = $self->getRole();
    my $host = $self->getHost();

    my $string = "\nuser_name\t$name\nuser_host\t$host\nuser_role\t$role\n";
    return $string;

}

1;
