####################################################################
# (C) Copyright 2007 Hewlett-Packard Development Company, L.P.
# @(#) Serviceguard preprocess.sh 
# @(#) Product Name                : HP Serviceguard
# @(#) Product Version             : A.12.10.00
# @(#) Patch Name                  : 
####################################################################

function show_var
{
    typeset name="$1"
    typeset value
    eval value="\${$name}"
    echo "$name=\"$value\""
}

# these lines describe the variables we are looking for
VARS="var:CONCURRENT_FSCK_OPERATIONS
      var:CONCURRENT_MOUNT_AND_UMOUNT_OPERATIONS
      var:CONCURRENT_VGCHANGE_OPERATIONS
      var:ENABLE_THREADED_VGCHANGE
      var:VXVM_DG_RETRY
      var:CVM_ACTIVATION_CMD
      arr:CVM_DG
      var:DEACTIVATION_RETRY_COUNT
      arr:DEFERRED_RESOURCE_NAME
      arr:DTC_NAME
      arr:LV:FS:FS_MOUNT_OPT:FS_UMOUNT_OPT:FS_FSCK_OPT:FS_TYPE
      var:FS_MOUNT_RETRY_COUNT
      var:FS_UMOUNT_COUNT
      var:HA_NFS_SCRIPT_EXTENSION
      var:EVFS_SCRIPT_EXTENSION
      arr:IP:SUBNET
      var:KILL_PROCESSES_ACCESSING_RAW_DEVICES
      arr:SERVICE_NAME:SERVICE_CMD:SERVICE_RESTART
      arr:VG
      var:VGCHANGE
      arr:VXVM_DG
      var:VXVOL
      var:MONITORED_SUBNET_ACCESS"

SGVARS="CONCURRENT_FSCK_OPERATIONS|CONCURRENT_MOUNT_AND_UMOUNT_OPERATIONS|CONCURRENT_VGCHANGE_OPERATIONS|ENABLE_THREADED_VGCHANGE|VXVM_DG_RETRY|CVM_ACTIVATION_CMD|CVM_DG|DEACTIVATION_RETRY|DEFERRED_RESOURCE_NAME|DTC_NAME|LV|FS|FS_MOUNT_OPT|FS_UMOUNT_OPT|FS_FSCK|FS_TYPE|FS_MOUNT_RETRY_COUNT|FS_UMOUNT_COUNT|HA_NFS_SCRIPT_EXTENSIONS|IP|SUBNET|VG|VGCHANGE|VXVM_DG|SERVICE_NAME|SERVICE_CMD|SERVICE_RESTART|VXVOL|KILL_PROCESSES_ACCESSING_RAW_DEVICES|EVFS_SCRIPT_EXTENSIONS|MONITORED_SUBNET_ACCESS"


# check the command line
if (( $# == 0 )) || [[ ! -f $1 ]]; then
    echo "Usage: ${0##*/} control_script"
    exit 1
fi

cntl=$1
# pick out the variable assignments and source them
data=$(awk < $cntl '
    /^# START OF CUSTOM/        { exit }
    /^#/                        { next }
    /^[[:space:]]*#/            { next }
    /^[[:space:]]*$/            { next }
    /^[[:space:]]*[^= ][^= ]*=/ { print; next }' | sed -e 's/\\\$/\\\\\\$/')

nonsgdata=$(cat $cntl |
sed -e '/# END OF CUSTOMER DEFINED FUNCTIONS/,$d' |
grep ^[A-Z_.-]*[*[0-9]*]*= |
tr ';' '\012' |
egrep -v -i $SGVARS) 

eval "$data"

# write them out
for i in $VARS
do
  type=${i%%:*}
  name=${i#*:}

  # single variable case
  if [[ $type = "var" ]]; then
        echo "$data" | grep -i $name > /dev/null
        if (( $? == 0 )) 
        then
              show_var $name
        fi

  # array case
  else
        primary=${name%%:*}
        eval "count=\${#$primary[*]}"
        (( i = 0 ))
        while (( i < count ))
        do
               for var in $(echo "$name" | tr ':' ' ')
               do
	                 show_var "$var[$i]"
	       done
	       (( i = i + 1 ))
        done
  fi
done

echo "$nonsgdata"
